Package com.saxonica.ee.stream.watch

## Class ForEachGroupPartitionAction

- java.lang.Object
- - net.sf.saxon.event.Outputter
  - - net.sf.saxon.event.ProxyOutputter
    - - com.saxonica.ee.stream.feed.ItemFeed
      - - com.saxonica.ee.stream.watch.ForEachGroupPartitionAction

- All Implemented Interfaces:
    `javax.xml.transform.Result`, `Receiver`

      public class ForEachGroupPartitionAction
      extends ItemFeed

  This watch implements xsl:for-each-group in streaming mode, in cases where the population is being partitioned (that is, group-adjacent, group-starting-with, and group-ending-with), and where the population is not grounded. It is informed of the nodes or other items selected by the xsl:for-each instruction; when such an item is encountered, it locates the relevant (inverted) action representing the body of the for-each, and activates it.

  The feed is capable of handling a select expression that selects non-peer nodes (that is, one selected node that is a descendant of another). A top-level selected node is processed directly to the output receiver; a nested node is processed to create a temporary result tree, which is then appended to the output sequence when the processing of the outer selected node is complete.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected XPathContext` | `bodyContext` |
    `boolean` | `feedAppliesToWholeGroup` |

    - ### Fields inherited from class net.sf.saxon.event.Outputter

      `pipelineConfiguration, systemId`

    - ### Fields inherited from interface javax.xml.transform.Result

      `PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ForEachGroupPartitionAction​(WatchManager watchManager, ForEachGroup expression, ItemFeed result, XPathContext context)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `append​(Item node)` | Signal that an item (other than an element) that matches the selection has been found.
    `void` | `close()` | Finish evaluating the expression.
    `void` | `endSelectedParentNode​(Location locationId)` | Signal that the endElement event has occurred for the element whose startElement event caused the Watch to be activated.
    `protected Inversion` | `getInversion()` |
    `protected void` | `makeBodyContext()` |
    `void` | `open​(Terminator terminator)` | Start evaluating the expression.
    `void` | `setInversion​(Inversion inversion)` |
    `Receiver` | `startSelectedParentNode​(FleetingParentNode node, Location locationId)` | Signal that an element (or document node) has been found that matches the selection that this Watch is looking for.

    - ### Methods inherited from class com.saxonica.ee.stream.feed.ItemFeed

      `append, dynamicError, getContext, getExpression, getResult, getTerminator, hasFailed, processItems, setExpression, setHasFailed, setTerminator`

    - ### Methods inherited from class net.sf.saxon.event.ProxyOutputter

      `attribute, characters, comment, endDocument, endElement, getNextOutputter, namespace, open, processingInstruction, setLocation, setUnparsedEntity, startContent, startDocument, startElement, startElement, usesTypeAnnotations`

    - ### Methods inherited from class net.sf.saxon.event.Outputter

      `getConfiguration, getPipelineConfiguration, getStringReceiver, getSystemId, namespaces, setPipelineConfiguration, setSystemId`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.event.Receiver

      `handlesAppend`

- - ### Field Detail

    - #### bodyContext

          protected XPathContext bodyContext

    - #### feedAppliesToWholeGroup

          public boolean feedAppliesToWholeGroup

  - ### Constructor Detail

    - #### ForEachGroupPartitionAction

          public ForEachGroupPartitionAction​(WatchManager watchManager,
                                             ForEachGroup expression,
                                             ItemFeed result,
                                             XPathContext context)

  - ### Method Detail

    - #### setInversion

          public void setInversion​(Inversion inversion)

    - #### getInversion

          protected Inversion getInversion()

    - #### open

          public void open​(Terminator terminator)
                    throws XPathException

      Description copied from class: `ItemFeed`
      Start evaluating the expression. The default implementation does nothing.
      Overrides:
        `open` in class `ItemFeed`
      Parameters:
        `terminator` - used to achieve early exit
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### makeBodyContext

          protected void makeBodyContext()

    - #### startSelectedParentNode

          public Receiver startSelectedParentNode​(FleetingParentNode node,
                                                  Location locationId)
                                           throws XPathException

      Signal that an element (or document node) has been found that matches the selection that this Watch is looking for. This method is called by the WatchManager while processing the startElement event that matches the selection. For this purpose, any attributes selected by the last step in the selection are ignored
      Overrides:
        `startSelectedParentNode` in class `ItemFeed`
      Parameters:
        `node` - the element or document node whose start event has been matched
        `locationId` - the location associated with the element or document node (may be the location of the instruction that created it)
      Returns:
        a receiver that collects the contents of the selected node, or null
      Throws:
        `XPathException` - if a dynamic error occurs while processing the start-element event

    - #### append

          public void append​(Item node)
                      throws XPathException

      Signal that an item (other than an element) that matches the selection has been found.
      Specified by:
        `append` in interface `Receiver`
      Specified by:
        `append` in class `ItemFeed`
      Parameters:
        `node` - the item that was matched.
      Throws:
        `XPathException` - if the operation fails

    - #### endSelectedParentNode

          public void endSelectedParentNode​(Location locationId)
                                     throws XPathException

      Signal that the endElement event has occurred for the element whose startElement event caused the Watch to be activated.
      Overrides:
        `endSelectedParentNode` in class `ItemFeed`
      Parameters:
        `locationId` - the location of the node in the source, or of the instruction that created it
      Throws:
        `ValidationException` - May be raised if the constraint implemented by this Watch is violated @param locationId the location of the node in the source, or of the instruction that created it
        `XPathException` - May be raised if a constraint implemented by this Watch is violated

    - #### close

          public void close()
                     throws XPathException

      Description copied from class: `ItemFeed`
      Finish evaluating the expression.
      Specified by:
        `close` in interface `Receiver`
      Overrides:
        `close` in class `ItemFeed`
      Throws:
        `XPathException` - if a dynamic error occurs